SystemOrganization addCategory: #'Seaside-WebSocket-Core'!

WAObject subclass: #WAWebSocket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-WebSocket-Core'!

!WAWebSocket commentStamp: '<historical>' prior: 0!
I am a WebSocket.!

!WAWebSocket methodsFor: 'running' stamp: 'pmm 8/1/2010 13:47'!
fork
	"Fork the WebSocket's input process."
	self subclassResponsibility! !

!WAWebSocket methodsFor: 'events' stamp: 'pmm 8/1/2010 13:12'!
onClose: aNiladicBlock
	"Set the handler block to invoke when the socket is closed."
	self subclassResponsibility! !

!WAWebSocket methodsFor: 'events' stamp: 'pmm 8/1/2010 13:13'!
onError: aOnceArgumentBlock
	"Set the handler block to invoke when an error occurs.
	The argument will be the error."
	self subclassResponsibility! !

!WAWebSocket methodsFor: 'events' stamp: 'pmm 8/1/2010 13:13'!
onMessage: aOnceOrTwoArgumentBlock
	"Set the handler block to invoke when a message is received.
	The first argument will be the data.
	The second argument will be the type."
	self subclassResponsibility! !

!WAWebSocket methodsFor: 'running' stamp: 'pmm 8/1/2010 13:47'!
run
	"Run the WebSocket's input process."
	self subclassResponsibility! !

!WAWebSocket methodsFor: 'sending' stamp: 'pmm 8/1/2010 13:14'!
send: aString
	"Writes one frame worth of data."
	self subclassResponsibility! !

!WAWebSocket methodsFor: 'accessing' stamp: 'pmm 8/1/2010 13:54'!
timeout: seconds
	"Sets the underlying stream timeout."
	self subclassResponsibility! !

WAObject subclass: #WAWebSocketCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-WebSocket-Core'!

!WAWebSocketCreator commentStamp: '<historical>' prior: 0!
I create new instances of WebSocket. I abstract away the server specific ways to create new WebSockets.!

!WAWebSocketCreator methodsFor: 'instance creation' stamp: 'pmm 8/1/2010 13:05'!
newWebSocket
	"Answer a new WebSocket for the current request."
	self subclassResponsibility! !

!WARequestContext methodsFor: '*seaside-websocket-core' stamp: 'pmm 8/1/2010 13:33'!
newWebSocket
	^ (self properties at: #webSocketCreator) newWebSocket! !

!WARequestContext methodsFor: '*seaside-websocket-core' stamp: 'pmm 8/1/2010 13:29'!
webSocketCreator
	^ self properties at: #webSocketCreator! !

!WARequestContext methodsFor: '*seaside-websocket-core' stamp: 'pmm 8/1/2010 13:29'!
webSocketCreator: aWebSocketCreator
	self properties at: #webSocketCreator put: aWebSocketCreator! !
